# dbg_helpers.h File Reference

Functions to be used for debug printings. More...

`#include <new>`
`#include <map>`
`#include <stack>`
`#include "blob.hpp"`
`#include "str.hpp"`

Go to the source code of this file.

## Data Structures
struct | ArrayT< T[N]>
| Helper template class that provides C array length and item type. More...
struct | DumpTarget
| Class that represents the dump-into-string target. More...
struct | DumpTarget::KnownStructKey
| Used as a key into map of known object instances. More...
## Functions
template<typename E, typename T>
ArrayT< T >::item_t | ItemAtT (E idx, T &t, typename ArrayT< T >::item_t t_unk)
| Helper template function that returns item of array at given index or t_unk when index is out of bounds.
template<typename E, typename T>
ArrayT< T >::item_t | ItemAtT (E idx, T &t, typename ArrayT< T >::item_t t_unk, E idx_inv, typename ArrayT< T >::item_t t_inv)
| Helper template function that returns item of array at given index or t_inv when index == idx_inv or t_unk when index is out of bounds.
template<typename E, typename T>
CStrA | ComposeNameT (E value, T &t, const char *t_unk, E val_inv, const char *name_inv)
| Helper template function that returns compound bitfield name that is concatenation of names of each set bit in the given value or t_inv when index == idx_inv or t_unk when index is out of bounds.
CStrA | ValueStr (Trackdir td)
| Return name of given Trackdir.
CStrA | ValueStr (TrackdirBits td_bits)
| Return composed name of given TrackdirBits.
CStrA | ValueStr (DiagDirection dd)
| Return name of given DiagDirection.
CStrA | ValueStr (SignalType t)
| Return name of given SignalType.

## Detailed Description

Functions to be used for debug printings.

Definition in file dbg_helpers.h.

## Function Documentation

CStrA ValueStr | ( | SignalType | t | ) |

Return name of given SignalType.

Definition at line 52 of file dbg_helpers.cpp.

References CStrT< Tchar, TcaseInsensitive >::Format(), ItemAtT(), signal_type_names, and CBlobT< Titem_, Tbase_ >::Transfer().

CStrA ValueStr | ( | DiagDirection | dd | ) |

Return name of given DiagDirection.

Definition at line 38 of file dbg_helpers.cpp.

References diagdir_names, CStrT< Tchar, TcaseInsensitive >::Format(), INVALID_DIAGDIR, ItemAtT(), and CBlobT< Titem_, Tbase_ >::Transfer().

CStrA ValueStr | ( | TrackdirBits | td_bits | ) |

Return composed name of given TrackdirBits.

Definition at line 24 of file dbg_helpers.cpp.

References ComposeNameT(), CStrT< Tchar, TcaseInsensitive >::Format(), INVALID_TRACKDIR_BIT, trackdir_names, and CBlobT< Titem_, Tbase_ >::Transfer().

CStrA ValueStr | ( | Trackdir | td | ) |

Return name of given Trackdir.

Definition at line 16 of file dbg_helpers.cpp.

References CStrT< Tchar, TcaseInsensitive >::Format(), INVALID_TRACKDIR, ItemAtT(), trackdir_names, and CBlobT< Titem_, Tbase_ >::Transfer().

Referenced by DumpTarget::WriteEnumT().